---
title: "Built-in themes"
framework: angular
version: "36.1.0"
---

# Built-in themes

Built-in themes provide a starting point for theming your application.

Themes are objects imported from the `ag-grid-community` package and provided to grid instances using the `theme` grid option.

```js
import { themeBalham } from 'ag-grid-community';

// in template
<ag-grid-angular
    [theme]="theme"
/>

// in component class
public theme = themeBalham;
```

## Built-in Themes

- Quartz - Our default theme, with high contrast and generous padding. Will use the IBM Plex Sans font if available**⁺**.
- Balham - A more traditional theme modelled after a spreadsheet application.
- Material - A theme designed according to Google's [Material v2](https://m2.material.io/) design system. This theme looks great for simple applications with lots of white space, and is the obvious choice if the rest of your application uses Material Design. Will use the Google Roboto font if available**⁺**.
- Alpine - The default theme before Quartz. We recommend quartz for new projects; this theme is intended to ease migration to the Theming API for applications already using Alpine.

**⁺** You can load these fonts yourself or pass the `loadThemeGoogleFonts` grid option to load them from Google's CDN. See [Customising Fonts](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/theming-fonts/) for more information.

#### Built-in themes

```ts
import { CommonModule } from "@angular/common";
import { Component } from "@angular/core";
import { FormsModule } from "@angular/forms";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef } from "ag-grid-community";
import {
  ModuleRegistry,
  enableDevValidations,
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

@Component({
  standalone: true,
  imports: [AgGridAngular, FormsModule, CommonModule],
  selector: "my-app",
  template: `
    <div style="height: 100%; display: flex; flex-direction: column">
      <p style="flex: 0 1 0%">
        Theme:
        <select style="margin-right: 16px" [(ngModel)]="theme">
          <option *ngFor="let theme of themes" [ngValue]="theme.theme">
            {{ theme.label }}
          </option>
        </select>
      </p>
      <div style="flex: 1 1 0%">
        <ag-grid-angular
          style="height: 100%;"
          [columnDefs]="columnDefs"
          [defaultColDef]="defaultColDef"
          [rowData]="rowData"
          [theme]="theme"
          [sideBar]="true"
        />
      </div>
    </div>
  `,
})
export class AppComponent {
  themes = [
    { label: "themeQuartz", theme: themeQuartz },
    { label: "themeBalham", theme: themeBalham },
    { label: "themeMaterial", theme: themeMaterial },
    { label: "themeAlpine", theme: themeAlpine },
  ];
  theme = themeQuartz;

  columnDefs: ColDef[] = [
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ];

  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
  };

  rowData: any[] = (() => {
    const rowData: any[] = [];
    for (let i = 0; i < 10; i++) {
      rowData.push({
        make: "Toyota",
        model: "Celica",
        price: 35000 + i * 1000,
      });
      rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
      rowData.push({
        make: "Porsche",
        model: "Boxster",
        price: 72000 + i * 1000,
      });
    }
    return rowData;
  })();
}
```

[Live example: Built-in themes](https://www.ag-grid.com/archive/36.1.0/examples/themes/built-in-themes/angular)

## Customising Built-in Themes

Themes are simply preset configurations of parts and parameters. After choosing a theme as a starting point, you can:

1. Choose a different [Color Scheme](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/theming-colors/#colour-schemes) if required.
2. Use [Theme Parameters](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/theming-parameters/) to customise borders, compactness, fonts and more.
3. Use [Theme Parts](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/theming-parts/) mix and match elements from different themes, for example the icons from Quartz with the text inputs from Material.
4. [Write your own CSS](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/theming-css/) for unlimited control over grid appearance.


---
title: "Built-in themes"
framework: vue
version: "36.1.0"
---

# Built-in themes

Built-in themes provide a starting point for theming your application.

Themes are objects imported from the `ag-grid-community` package and provided to grid instances using the `theme` grid option.

```js
import { themeBalham } from 'ag-grid-community';

// in template
<ag-grid-vue
    :theme="theme"
    ...
></ag-grid-vue>

// in component setup hook
setup() {
    return {
        theme: themeBalham,
    };
}
```

## Built-in Themes

- Quartz - Our default theme, with high contrast and generous padding. Will use the IBM Plex Sans font if available**⁺**.
- Balham - A more traditional theme modelled after a spreadsheet application.
- Material - A theme designed according to Google's [Material v2](https://m2.material.io/) design system. This theme looks great for simple applications with lots of white space, and is the obvious choice if the rest of your application uses Material Design. Will use the Google Roboto font if available**⁺**.
- Alpine - The default theme before Quartz. We recommend quartz for new projects; this theme is intended to ease migration to the Theming API for applications already using Alpine.

**⁺** You can load these fonts yourself or pass the `loadThemeGoogleFonts` grid option to load them from Google's CDN. See [Customising Fonts](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/theming-fonts/) for more information.

#### Built-in themes

```ts
import { createApp, defineComponent, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  ModuleRegistry,
  enableDevValidations,
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%; display: flex; flex-direction: column">
            <p style="flex: 0 1 0%">
                Theme:
                <select style="margin-right: 16px" v-model="theme">
                    <option v-for="(theme, id) in themes" :value="theme">{{ id }}</option>
                </select>
            </p>
            <div style="flex: 1 1 0%">
                <ag-grid-vue
                    style="height: 100%;"
                    :theme="theme"
                    :columnDefs="columnDefs"
                    :defaultColDef="defaultColDef"
                    :rowData="rowData"
                    :sideBar="true"
                ></ag-grid-vue>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup() {
    const theme = ref(themeQuartz);
    return {
      theme,
      themes: {
        themeQuartz,
        themeBalham,
        themeMaterial,
        themeAlpine,
      },

      columnDefs: <ColDef[]>[
        { field: "make" },
        { field: "model" },
        { field: "price" },
      ],
      defaultColDef: <ColDef>{
        editable: true,
        flex: 1,
        minWidth: 100,
        filter: true,
      },
      rowData: <any[]>(() => {
        const rowData = [];
        for (let i = 0; i < 10; i++) {
          rowData.push({
            make: "Toyota",
            model: "Celica",
            price: 35000 + i * 1000,
          });
          rowData.push({
            make: "Ford",
            model: "Mondeo",
            price: 32000 + i * 1000,
          });
          rowData.push({
            make: "Porsche",
            model: "Boxster",
            price: 72000 + i * 1000,
          });
        }
        return rowData;
      })(),
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Built-in themes](https://www.ag-grid.com/archive/36.1.0/examples/themes/built-in-themes/vue3)

## Customising Built-in Themes

Themes are simply preset configurations of parts and parameters. After choosing a theme as a starting point, you can:

1. Choose a different [Color Scheme](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/theming-colors/#colour-schemes) if required.
2. Use [Theme Parameters](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/theming-parameters/) to customise borders, compactness, fonts and more.
3. Use [Theme Parts](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/theming-parts/) mix and match elements from different themes, for example the icons from Quartz with the text inputs from Material.
4. [Write your own CSS](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/theming-css/) for unlimited control over grid appearance.


---
title: "Built-in themes"
framework: react
version: "36.1.0"
---

# Built-in themes

Built-in themes provide a starting point for theming your application.

Themes are objects imported from the `ag-grid-community` package and provided to grid instances using the `theme` grid option.

```js
import { themeBalham } from 'ag-grid-community';

<AgGridReact
    theme={themeBalham}
    ...
/>
```

## Built-in Themes

- Quartz - Our default theme, with high contrast and generous padding. Will use the IBM Plex Sans font if available**⁺**.
- Balham - A more traditional theme modelled after a spreadsheet application.
- Material - A theme designed according to Google's [Material v2](https://m2.material.io/) design system. This theme looks great for simple applications with lots of white space, and is the obvious choice if the rest of your application uses Material Design. Will use the Google Roboto font if available**⁺**.
- Alpine - The default theme before Quartz. We recommend quartz for new projects; this theme is intended to ease migration to the Theming API for applications already using Alpine.

**⁺** You can load these fonts yourself or pass the `loadThemeGoogleFonts` grid option to load them from Google's CDN. See [Customising Fonts](https://www.ag-grid.com/archive/36.1.0/react-data-grid/theming-fonts/) for more information.

#### Built-in themes

```tsx
'use client';
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

const themes = [
  { id: "themeQuartz", theme: themeQuartz },
  { id: "themeBalham", theme: themeBalham },
  { id: "themeMaterial", theme: themeMaterial },
  { id: "themeAlpine", theme: themeAlpine },
];

const GridExample = () => {
  const [theme, setBaseTheme] = useState(themes[0]);

  return (
    <AgGridProvider modules={[AllEnterpriseModule]}>
      <div style={{ height: "100%", display: "flex", flexDirection: "column" }}>
        <p style={{ flex: 0 }}>
          Theme:{" "}
          <PartSelector
            options={themes}
            value={theme}
            setValue={setBaseTheme}
          />
        </p>
        <div style={{ flex: 1 }}>
          <AgGridReact
            theme={theme.theme}
            columnDefs={columnDefs}
            rowData={rowData}
            defaultColDef={defaultColDef}
            sideBar
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

type PartSelectorProps<T extends { id: string } | null> = {
  options: T[];
  value: T;
  setValue: (value: T) => void;
};

const PartSelector = <T extends { id: string; variant?: string } | null>({
  options,
  value,
  setValue,
}: PartSelectorProps<T>) => (
  <select
    onChange={(e) =>
      setValue(options.find((t) => t?.id === e.currentTarget.value)! || null)
    }
    style={{ marginRight: 16 }}
    value={value?.id}
  >
    {options.map((option, i) => (
      <option key={i} value={option?.id}>
        {option?.variant || option?.id || "(unchanged)"}
      </option>
    ))}
  </select>
);

const rowData: any[] = (() => {
  const rowData: any[] = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({ make: "Toyota", model: "Celica", price: 35000 + i * 1000 });
    rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
    });
  }
  return rowData;
})();

const columnDefs = [{ field: "make" }, { field: "model" }, { field: "price" }];

const defaultColDef = {
  editable: true,
  flex: 1,
  minWidth: 100,
  filter: true,
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Built-in themes](https://www.ag-grid.com/archive/36.1.0/examples/themes/built-in-themes/reactFunctionalTs)

## Customising Built-in Themes

Themes are simply preset configurations of parts and parameters. After choosing a theme as a starting point, you can:

1. Choose a different [Color Scheme](https://www.ag-grid.com/archive/36.1.0/react-data-grid/theming-colors/#colour-schemes) if required.
2. Use [Theme Parameters](https://www.ag-grid.com/archive/36.1.0/react-data-grid/theming-parameters/) to customise borders, compactness, fonts and more.
3. Use [Theme Parts](https://www.ag-grid.com/archive/36.1.0/react-data-grid/theming-parts/) mix and match elements from different themes, for example the icons from Quartz with the text inputs from Material.
4. [Write your own CSS](https://www.ag-grid.com/archive/36.1.0/react-data-grid/theming-css/) for unlimited control over grid appearance.
